#!/bin/bash

# updated
VERSIONDATE="2556-06-14"

# change you server here
MYSERVER="10.0.100.100"
MYFILE="dhcpd.txt"
TEMP1=$(mktemp)

if [ -z "${1}" ] ; then
  MAC=$(ifconfig eth0|grep -i -o "ether.*"|awk '{print $2}')
  wget http://${MYSERVER}/${MYFILE} -O ${TEMP1}
  MYAREA=$(grep -i "${MAC}" ${TEMP1}|grep -v "^[[:space:]]*#"|awk '{print $2}'|grep -i "zone"|head -1|cut -d'_' -f1)
  if [ -z "${MYAREA}" ] ; then
    echo "SORRY; Not listed IP zone?"
    exit
  fi
else
  MYAREA="${1}"
fi

MYHD="sda"
MYDISK="/dev/${MYHD}"
MYZONE="/var/www/cloning/${MYAREA}"

# checks
if [ -z "$(grep "${MYHD}" /proc/partitions)" ] ; then
  echo "Error: Can't find /dev/${MYHD}"
  exit 0
fi

if [ -n "$(df|grep "/mnt/custom")" ] ; then
  umount /mnt/custom
fi
echo "Connecting to server ${MYSERVER}"
sshfs  papa@${MYSERVER}:${MYZONE} /mnt/custom

MYIP=$(ifconfig eth0|grep -w "inet"|awk '{print $2}'|cut -d':' -f 2)
while true ; do
  echo
  echo "PSU12-Sritrang (${VERSIONDATE}) backup to ${MYSERVER} from PC IP = ${MYIP}"
  echo
  echo "0. Exit"
  parted -s ${MYDISK} print|grep "^ [0-9]"|grep -v -i "extended"|grep -v -i "swap" > ${TEMP1}
  MYTEST="1 2 3 4 5 6 7 8 9"
  KEY=""
  for ID in ${MYTEST} ; do
    CHECK=$(grep "^ ${ID} " ${TEMP1})
    if [ -n "${CHECK}" ] ; then
      KEY="${KEY}${ID}"
      TYPE=$(echo ${CHECK}|awk '{print $6}')
      echo "${ID}. backup ${MYDISK}${ID}-${TYPE} to ${MYSERVER}:${MYZONE}"
    fi
  done
  echo
  echo "M. backup ${MYHD} Master boot record to ${MYSERVER}:${MYZONE}"
  echo "N. No (clear) hidden flag all partitions before backup"
  echo "P. backup ${MYHD} Partition table to ${MYSERVER}:${MYZONE}"
  echo "Y. (M+N+P)"
  echo
  echo "R. ${MYAREA} RESTORE menu	V. Reboot        W. Poweroff"
  echo
  echo -n "Please select choice from menu [0${KEY} MNPYRVW] "
  read CHOICE
  case "${CHOICE}" in
    0)
      umount /mnt/custom
      exit 0
      ;;
    [${KEY}])
      date
      MYPART="${MYDISK}${CHOICE}"
      MYFS=$(parted -s ${MYDISK} print |grep "^ ${CHOICE} "|awk '{print $6}')
      IS_NTFS=$(echo ${MYFS}|grep -i "ntfs")
      if [ -n "${IS_NTFS}" ] ; then
        echo "ntfs-3g ${MYPART} /mnt/windows"
        echo "rm -f /mnt/windows/pagefile.sys"
        echo "umount /mnt/windows"
        echo "ntfsclone -s -o - ${MYPART} | gzip -c > /mnt/custom/${MYAREA}-${MYHD}${CHOICE}-N.gz"
### start backup NTFS partition
        ntfs-3g ${MYPART} /mnt/windows
        rm -f /mnt/windows/pagefile.sys
        umount /mnt/windows
        ntfsclone -s -o - ${MYPART}|gzip -c > /mnt/custom/${MYAREA}-${MYHD}${CHOICE}-N.gz
### end of backup NTFS partition
      else
        IS_FAT=$(echo ${MYFS}|grep -i "fat")
        if [ -n "${IS_FAT}" ] ; then
          echo "mount ${MYPART} /mnt/windows"
          echo "rm -f /mnt/windows/pagefile.sys"
          echo "umount /mnt/windows" 
          echo "partclone.fat -c -C -R -s ${MYPART} -I --ignore_crc -o -|gzip -c > /mnt/custom/${MYAREA}-${MYHD}${CHOICE}-F.gz"
### start backup FAT partition
          mount ${MYPART} /mnt/windows
          rm -f /mnt/windows/pagefile.sys
          umount /mnt/windows 
          partclone.fat -c -C -R -s ${MYPART} -I --ignore_crc -o -|gzip -c > /mnt/custom/${MYAREA}-${MYHD}${CHOICE}-F.gz
### end of backup FAT partition
        else
          IS_EXT=$(echo ${MYFS}|grep -i "ext")
          if [ -n "${IS_EXT}" ] ; then
	    echo "tune2fs -O extents,uninit_bg,dir_index ${MYDISK}${CHOICE}"
	    echo "fsck -pf ${MYDISK}${CHOICE}"
            echo "partclone.extfs -c -C -R -s ${MYPART} -I --ignore_crc -o -|gzip -c > /mnt/custom/${MYAREA}-${MYHD}${CHOICE}-E.gz"
	    tune2fs -O extents,uninit_bg,dir_index ${MYDISK}${CHOICE}
	    fsck -pf ${MYDISK}${CHOICE}
            partclone.extfs -c -C -R -s ${MYPART} -I --ignore_crc -o -|gzip -c > /mnt/custom/${MYAREA}-${MYHD}${CHOICE}-E.gz
          else
            echo "Error: unknowned filesystem of ${MYPART}"
            contiune
          fi
        fi
      fi
      echo
      date
      echo "Done. press Enter to Continue "
      read ANYKEY
      ;;
    M)
#      echo "dd if=${MYDISK} bs=512 count=63 of=/mnt/custom/${MYAREA}-${MYHD}.mbr"
#      dd if=${MYDISK} bs=512 count=63 of=/mnt/custom/${MYAREA}-${MYHD}.mbr
### start BACKUP master boot record
      TOTAL=$(sfdisk -uS -q -d ${MYDISK} 2>/dev/null |grep "${MYDISK}1"|cut -d',' -f1|cut -d '=' -f 2|awk '{print $1}')
      echo "dd if=${MYDISK} bs=512 count=${TOTAL} of=/mnt/custom/${MYAREA}-${MYHD}.mbr"
      dd if=${MYDISK} bs=512 count=${TOTAL} of=/mnt/custom/${MYAREA}-${MYHD}.mbr
### end here
      echo
      echo "------------------------------------"
      echo "Done. press Enter to Continue "
      echo "------------------------------------"
      read ANYKEY
      ;;
    N) 
      #parted -s ${MYDISK} set 1 hidden off set 2 hidden off set 3 hidden off
      for ID in ${MYTEST} ; do
        CHECK=$(grep "^ ${ID} " ${TEMP1})
        if [ -n "${CHECK}" ] ; then
          if [ "${ID}" == "1" ]; then
            echo "set partition 1 hidden off"
            parted -s ${MYDISK} set 1 hidden off
          fi
          if [ "${ID}" == "2" ]; then
            echo "set partition 2 hidden off"
            parted -s ${MYDISK} set 2 hidden off
          fi
          if [ "${ID}" == "3" ]; then
            echo "set partition 3 hidden off"
            parted -s ${MYDISK} set 3 hidden off
          fi
        fi
      done
      echo
      echo "------------------------------------"
      echo "Done. press Enter to Continue "
      echo "------------------------------------"
      read ANYKEY
      ;;
    P)
      echo "sfdisk -d ${MYDISK} > /mnt/custom/${MYAREA}-${MYHD}.part"
### start BACKUP partition table
      sfdisk -d ${MYDISK} > /mnt/custom/${MYAREA}-${MYHD}.part
### end here
      echo
      echo "------------------------------------"
      echo "Done. press Enter to Continue "
      echo "------------------------------------"
      read ANYKEY
      ;;
    R)
      exec sh welcome.sh ${MYAREA}
      ;;
    Y)
#      echo "dd if=${MYDISK} bs=512 count=63 of=/mnt/custom/${MYAREA}-${MYHD}.mbr"
#      dd if=${MYDISK} bs=512 count=63 of=/mnt/custom/${MYAREA}-${MYHD}.mbr
### start BACKUP master boot record
      # start M)
      TOTAL=$(sfdisk -uS -q -d ${MYDISK} 2>/dev/null |grep "${MYDISK}1"|cut -d',' -f1|cut -d '=' -f 2|awk '{print $1}')
      echo "dd if=${MYDISK} bs=512 count=${TOTAL} of=/mnt/custom/${MYAREA}-${MYHD}.mbr"
      dd if=${MYDISK} bs=512 count=${TOTAL} of=/mnt/custom/${MYAREA}-${MYHD}.mbr
### end here
      echo
      echo "------------------------------------"
      echo "Done. M Backup Ok "
      echo "------------------------------------"
      # start N)
      #parted -s ${MYDISK} set 1 hidden off set 2 hidden off set 3 hidden off
      for ID in ${MYTEST} ; do
        CHECK=$(grep "^ ${ID} " ${TEMP1})
        if [ -n "${CHECK}" ] ; then
          if [ "${ID}" == "1" ]; then
            echo "set partition 1 hidden off"
            parted -s ${MYDISK} set 1 hidden off
          fi
          if [ "${ID}" == "2" ]; then
            echo "set partition 2 hidden off"
            parted -s ${MYDISK} set 2 hidden off
          fi
          if [ "${ID}" == "3" ]; then
            echo "set partition 3 hidden off"
            parted -s ${MYDISK} set 3 hidden off
          fi
        fi
      done
      echo
      echo "------------------------------------"
      echo "Done. N Backup Ok "
      echo "------------------------------------"
      # start P)
      echo "sfdisk -d ${MYDISK} > /mnt/custom/${MYAREA}-${MYHD}.part"
### start BACKUP partition table
      sfdisk -d ${MYDISK} > /mnt/custom/${MYAREA}-${MYHD}.part
### end here
      echo
      echo "------------------------------------"
      echo "Done. P Backup Ok "
      echo "Done. press Enter to Continue "
      echo "------------------------------------"
      read ANYKEY
      ;;

    V)
      echo "!!! Server to Reboot Now Please Wait..."
      reboot
      ;;
    W)
      echo "!!! Server to Shutdown Now Please Wait..."
      poweroff
      ;;
    *)
      continue
      ;;
  esac
done

