#!/bin/bash

# install grub2
# last updated by WIPAT 2554-08-19

CHECKMOUNT=$(df|grep "/mnt/custom")
if [ -z "${CHECKMOUNT}" ] ; then
  echo "error, you need to mount /mnt/custom"
  exit
fi

TEMP1="/tmp/temp1.txt"
TEMP2="/tmp/temp2.txt"

MYPART=$(df|grep -w "/mnt/custom"|awk '{print $1}')
MYID=$(echo "${MYPART}"|cut -d'/' -f 3)
NUM=$(echo "${MYID}"|cut -c 4)
NEWUUID=$(ls -l --time-style=long-iso /dev/disk/by-uuid|grep "${MYID}"|awk '{print $8}')

INPUTFILE="/mnt/custom/boot/grub/grub.cfg"
OLDUUID=$(grep -i -m 1 "fs-uuid" ${INPUTFILE}|awk '{print $5}')
sed "s/${OLDUUID}/${NEWUUID}/" ${INPUTFILE} |sed "s/hd0,1/hd0,${NUM}/"|sed "s/hd0,msdos1/hd0,msdos${NUM}/" > ${TEMP1}
echo "updating ${INPUTFILE}"
echo "change ${OLDUUID} to ${NEWUUID}"
echo 
cp -f ${TEMP1} ${INPUTFILE}

INPUTFILE="/mnt/custom/etc/fstab"
OLDUUID=$(grep -i "^UUID" ${INPUTFILE}|grep "ext"|awk '{print $1}'|cut -d'=' -f2)
sed "s;${MYPART};UUID=${NEWUUID};" ${INPUTFILE}|sed "s/${OLDUUID}/${NEWUUID}/" > ${TEMP1}
echo "updating ${INPUTFILE}"
echo "change ${OLDUUID} to ${NEWUUID}"

OLDUUID=$(grep -i "^UUID" ${TEMP1}|grep "swap"|awk '{print $1}'|cut -d'=' -f2)
if [ -z "${OLDUUID}" ] ; then
  echo "ERROR: linux-swap file system not found."
  exit
fi
MYDISK=$(echo ${MYPART}|cut -c 1-8)
MYPART=$(fdisk -l|grep ${MYDISK}|grep -i "Linux swap"|awk '{print $1}')
MYID=$(echo "${MYPART}"|cut -d'/' -f 3)
NEWUUID=$(ls -l --time-style=long-iso /dev/disk/by-uuid|grep "${MYID}"|awk '{print $8}')
sed "s/${OLDUUID}/${NEWUUID}/" ${TEMP1} > ${TEMP2}
echo "change ${OLDUUID} to ${NEWUUID}"
cp -f ${TEMP2} ${INPUTFILE}

ROOTDIR="/mnt/custom"
MYPART=$(df|grep "/mnt/custom"|awk '{print $1}')
MYDISK=$(echo ${MYPART}|cut -c 1-8)
echo "grub-install --recheck --root-directory=${ROOTDIR} ${MYDISK}"
#grub2-install --recheck --root-directory=${ROOTDIR} ${MYDISK}
for ID in /dev /dev/pts /proc /sys ; do
  mount --bind ${ID} ${ROOTDIR}${ID}
done
chroot ${ROOTDIR} /bin/bash -c "grub-install --recheck ${MYDISK}"
for ID in /sys /proc /dev/pts /dev ; do
  umount ${ROOTDIR}${ID}
done

rm -f ${TEMP1} ${TEMP2}
