#!/bin/bash

# updated 2554-10-06

# updated
VERSIONDATE="2556-06-14"

MAXBITRATE="110m"

if [ -z "${1}" ] ; then
  echo "which zone?"
  exit
else
  MYAREA="${1}"
fi
MYSERVER=$(ifconfig eth0|grep "inet addr"|cut -d':' -f 2|cut -d' ' -f 1)
MYHD="sda"
MYZONE="/var/www/cloning/${MYAREA}"
SOURCE="${MYZONE}/${MYAREA}-sendfile"

TEMP1=$(mktemp)
TEMP2=$(mktemp)
ls -1 ${MYZONE}|grep "\.gz"  > ${TEMP1}
# checks
if [ ! -f ${TEMP1} ] ; then
  echo "Sorry: ${MYZONE} no file existed"
  exit 0
fi

while true ; do
  echo
  echo "PSU12-Sritrang(${VERSIONDATE}) MULTICAST sender from ${MYSERVER}:${MYZONE}"
  echo
  echo "0. Exit"
  KEY=""
  COUNT="0"
  cat /dev/null > ${TEMP2}
  while read LINE ; do
    COUNT=$(expr ${COUNT} + 1)
    KEY="${KEY}${COUNT}"
    echo "${COUNT}. ${MYAREA} MULTICAST send ${LINE} image"
    echo "${COUNT}:${LINE}" >> ${TEMP2}
  done < ${TEMP1}
  echo 
  echo -n "Please select choice from menu [0${KEY}] "
  read CHOICE
  case "$CHOICE" in
    0)
      exit 0
      ;;
    [${KEY}])
      START_TIME=$(date)
      MYFILE=$(grep "${CHOICE}:" ${TEMP2}|cut -d':' -f2)
      echo "${MYFILE}" > ${SOURCE}
      echo "udp-sender --file ${MYZONE}/${MYFILE} --max-bitrate ${MAXBITRATE} --retriesUntilDrop 20 --interface eth0"
### start MULTICAST send NTFS partition 1
      udp-sender --file ${MYZONE}/${MYFILE} --max-bitrate ${MAXBITRATE} --retriesUntilDrop 20 --interface eth0
### end here
      STOP_TIME=$(date)
      echo 
      echo "Start = ${START_TIME}"
      echo "Stop = ${STOP_TIME}"
      echo "Done. press Enter to continue "
      read ANYKEY
      ;;
  esac
done

rm ${TEMP1} ${TEMP2}
