#!/bin/bash

# updated 
VERSIONDATE="2556-06-14"

# change you server here
MYSERVER="10.0.100.100"
MYFILE="dhcpd.txt"
MYSTART="mystart.txt"
echo "start-here" > ${MYSTART}
TEMP1=$(mktemp)
TEMP2=$(mktemp)

if [ -z "${1}" ] ; then
  MAC=$(ifconfig eth0|grep -i -o "ether.*"|awk '{print $2}')
  wget http://${MYSERVER}/${MYFILE} -O ${TEMP1}
  MYAREA=$(grep -i "${MAC}" ${TEMP1}|grep -v "^[[:space:]]*#"|awk '{print $2}'|grep -i "zone"|head -1|cut -d'_' -f1)
  if [ -z "${MYAREA}" ] ; then
    echo "SORRY; Not listed IP zone?"
    exit
  fi
else
  MYAREA="${1}"
fi

MYHD="sda"
MYDISK="/dev/${MYHD}"
MYZONE="/var/www/cloning/${MYAREA}"

# checks
if [ -z "$(grep "${MYHD}" /proc/partitions)" ] ; then
  echo "Error: Can't find /dev/${MYHD}"
  exit 0
fi

MYIP=$(ifconfig eth0|grep -w "inet"|awk '{print $2}'|cut -d':' -f 2)
while true ; do
  echo 
  echo "PSU12-Sritrang (${VERSIONDATE}) restore form ${MYSERVER} to PC IP = ${MYIP}"
  echo
  echo "0. Exit"
  parted -s ${MYDISK} print|grep "^ [0-9]"|grep -v -i "extended"|grep -v -i "swap" > ${TEMP1}
  MYTEST="1 2 3 4 5 6 7 8 9"
  KEY=""
  for ID in ${MYTEST} ; do
    CHECK=$(grep "^ ${ID} " ${TEMP1})
    if [ -n "${CHECK}" ] ; then
      TYPE=$(echo ${CHECK}|awk '{print $6}')
      KEY="${KEY}${ID}"
      echo "${ID}. SINGLE restore ${MYSERVER}:${MYZONE} to ${MYDISK}${ID}-${TYPE} "
    fi
  done
  echo
  MCAST=""
  BASE="40"
  for ID in ${MYTEST} ; do
    CHECK=$(grep "^ ${ID} " ${TEMP1})
    if [ -n "${CHECK}" ] ; then
      TYPE=$(echo ${CHECK}|awk '{print $6}')
      NUM=$(expr ${BASE} + ${ID})
      CODE="\\x${NUM}"
      MCAST=$(echo -e -n "${MCAST}${CODE}")
      echo -e "${CODE}. MULTICAST restore ${MYSERVER}:${MYZONE} to ${MYDISK}${ID}-${TYPE}"
    fi
  done
  echo
  echo "M. ${MYSERVER}:${MYZONE} restore Master Boot Record to ${MYDISK}"
  echo "P. ${MYSERVER}:${MYZONE} restore Partition + FORMAT to ${MYDISK}"
  echo "Y. (M+P)" 
  echo
  echo "R. Set Active ${MYDISK}1 Hidden ${MYDISK}2 Hidden ${MYDISK}3"
  echo "S. Set Active ${MYDISK}2 Hidden ${MYDISK}1 Hidden ${MYDISK}3"
  echo "T. Set Active ${MYDISK}3 Hidden ${MYDISK}1 Hidden ${MYDISK}2"
  echo "N. No (clear) hidden flag all partitions"
  echo
  echo "X. ${MYAREA} BACKUP menu	V. Reboot	W. Poweroff" 
  echo
  echo -n "Please select choice from menu [0${KEY} ${MCAST} MPYRSTNXVW] " 
  echo
  read CHOICE
  case "$CHOICE" in
    0)
      exit 0
      ;;
    [${KEY}])
      START_TIME=$(date)
      MYPART="${MYDISK}${CHOICE}"
      MYFS=$(parted -s ${MYDISK} print |grep "^ ${CHOICE} "|awk '{print $6}')
      IS_NTFS=$(echo ${MYFS}|grep -i "ntfs")
      if [ -n "${IS_NTFS}" ] ; then
        echo "wget http://${MYSERVER}/cloning/${MYAREA}/${MYAREA}-${MYHD}${CHOICE}-N.gz -O -|gunzip|ntfsclone -r -O ${MYPART} -"
### start SINGLE restore NTFS partition
        wget "http://${MYSERVER}/cloning/${MYAREA}/${MYAREA}-${MYHD}${CHOICE}-N.gz" -O -|gunzip|ntfsclone -r -O ${MYPART} -
### end here
      else
        IS_FAT=$(echo ${MYFS}|grep -i "fat")
        if [ -n "${IS_FAT}" ] ; then
          echo "wget http://${MYSERVER}/cloning/${MYAREA}/${MYAREA}-${MYHD}${CHOICE}-F.gz -O -|gunzip|partclone.fat -r -C -R -o ${MYPART}"
### start SINGLE restore FAT32 partition
          wget http://${MYSERVER}/cloning/${MYAREA}/${MYAREA}-${MYHD}${CHOICE}-F.gz -O -|gunzip|partclone.fat -r -C -R -o ${MYPART}
### end here
        else
          IS_EXT=$(echo ${MYFS}|grep -i "ext")
          if [ -n "${IS_EXT}" ] ; then
            echo "wget http://${MYSERVER}/cloning/${MYAREA}/${MYAREA}-${MYHD}${CHOICE}-E.gz -O -|gunzip|partclone.extfs -r -C -R -o ${MYPART}"
            wget http://${MYSERVER}/cloning/${MYAREA}/${MYAREA}-${MYHD}${CHOICE}-E.gz -O -|gunzip|partclone.extfs -r -C -R -o ${MYPART}
          fi
        fi
      fi
      STOP_TIME=$(date)
      echo
      echo "Start = ${START_TIME}"
      echo "Stop = ${STOP_TIME}"
      echo "Done. press Enter to continue "
      read ANYKEY
      ;;
    [${MCAST}])
      VALUE=$(echo "${CHOICE}"|od -t x1 -N 1 -A n)
      NUM=$(expr ${VALUE} - ${BASE})
      MYPART="${MYDISK}${NUM}"
      wget http://${MYSERVER}/cloning/${MYAREA}/${MYAREA}-sendfile -O ${TEMP2}
      CHECK=$(grep "\-N\.gz" ${TEMP2})
      if [ -n "${CHECK}" ] ; then
        echo "udp-receiver --nokbd --nosync|gunzip -c|ntfsclone -r -O ${MYPART} -"
### start MULTCAST restore NTFS partition
      udp-receiver --nokbd --nosync|gunzip -c|ntfsclone -r -O ${MYPART} -
### end here
      else
        CHECK=$(grep "\-F\.gz" ${TEMP2})
        if [ -n "${CHECK}" ] ; then
          echo "udp-receiver --nokbd --nosync|gunzip -c|partclone.fat -r -C -R -o ${MYPART}"
### start MULTCAST restore FAT partition
          udp-receiver --nokbd --nosync|gunzip -c|partclone.fat -r -C -R -o ${MYPART}
### end here
        else
          CHECK=$(grep "\-E\.gz" ${TEMP2})
          if [ -n "${CHECK}" ] ; then
            echo "udp-receiver --nokbd --nosync|gunzip -c|partclone.extfs -r -C -R -o ${MYPART}"
### start MULTCAST restore EXT partition
            udp-receiver --nokbd --nosync|gunzip -c|partclone.extfs -r -C -R -o ${MYPART}
### end here
          fi
        fi
      fi
      echo
      echo "Done. press Enter to continue "
      read ANYKEY
      ;; 
    M)
      echo "wget http://${MYSERVER}/cloning/${MYAREA}/${MYAREA}-${MYHD}.mbr -O -|dd of=${MYDISK}"
### start RESTORE master boot record
      wget "http://${MYSERVER}/cloning/${MYAREA}/${MYAREA}-${MYHD}.mbr" -O -|dd of=${MYDISK}
### end here
      echo
      echo "------------------------------------"
      echo "Done. press Enter to continue "
      echo "------------------------------------"
      read ANYKEY
      ;;
    P)
      echo "wget http://${MYSERVER}/cloning/${MYAREA}/${MYAREA}-${MYHD}.part -O -|sfdisk --force ${MYDISK}"
### start RESTORE partition table
      wget "http://${MYSERVER}/cloning/${MYAREA}/${MYAREA}-${MYHD}.part" -O -|sfdisk --force ${MYDISK}
      sleep 5
      fdisk -l ${MYDISK}|grep "^${MYDISK}"|grep -v -i "Extended" > ${TEMP1}
      MYTEST="1 2 3 4 5 6 7 8 9"
      for ID in ${MYTEST} ; do
        CHECK=$(grep "^${MYDISK}${ID} " ${TEMP1})
        if [ -n "${CHECK}" ] ; then
          IS_NTFS=$(echo ${CHECK}|grep -i "NTFS")
          if [ -n "${IS_NTFS}" ] ; then
            echo "mkntfs -f -F ${MYDISK}${ID}"
            mkntfs -f -F ${MYDISK}${ID}
          else
            IS_FAT=$(echo ${CHECK}|grep -i "FAT")
            if [ -n "${IS_FAT}" ] ; then
              echo "mkfs.vfat ${MYDISK}${ID}"
              mkfs.vfat ${MYDISK}${ID}
            else
              IS_EXT=$(echo ${CHECK}|grep -i -w "83")
              if [ -n "${IS_EXT}" ] ; then
                echo "mkfs.ext3 ${MYDISK}${ID}"
                mkfs.ext3 ${MYDISK}${ID}
              else
                IS_SWAP=$(echo ${CHECK}|grep -i -w "82")
                if [ -n "${IS_SWAP}" ] ; then
                  echo "mkswap ${MYDISK}${ID}"
                  mkswap ${MYDISK}${ID}
                fi
              fi
            fi
          fi
        fi
      done
### end here
      echo
      echo "------------------------------------"
      echo "Done. press Enter to continue "
      echo "------------------------------------"
      read ANYKEY
      ;;
    R)
      #parted -s ${MYDISK} set 1 hidden off set 2 hidden on set 3 hidden on set 1 boot on
      for ID in ${MYTEST} ; do
        CHECK=$(grep "^ ${ID} " ${TEMP1})
        if [ -n "${CHECK}" ] ; then
          if [ "${ID}" == "1" ]; then
            echo "set partition 1 hidden off"
            parted -s ${MYDISK} set 1 hidden off
            echo "set partition 1 boot on"
            parted -s ${MYDISK} set 1 boot on 
          fi
          if [ "${ID}" == "2" ]; then
            echo "set partition 2 hidden on"
            parted -s ${MYDISK} set 2 hidden on
          fi
          if [ "${ID}" == "3" ]; then
            echo "set partition 3 hidden on"
            parted -s ${MYDISK} set 3 hidden on
          fi
        fi
      done
      echo
      echo "Done. press Enter to continue "
      read ANYKEY
      ;;
    S)
      #parted -s ${MYDISK} set 1 hidden on set 2 hidden off set 3 hidden on set 2 boot on
      for ID in ${MYTEST} ; do
        CHECK=$(grep "^ ${ID} " ${TEMP1})
        if [ -n "${CHECK}" ] ; then
          if [ "${ID}" == "1" ]; then
            echo "set partition 1 hidden on"
            parted -s ${MYDISK} set 1 hidden on
          fi
          if [ "${ID}" == "2" ]; then
            echo "set partition 2 hidden off"
            parted -s ${MYDISK} set 2 hidden off
            echo "set partition 2 boot on"
            parted -s ${MYDISK} set 2 boot on 
          fi
          if [ "${ID}" == "3" ]; then
            echo "set partition 3 hidden on"
            parted -s ${MYDISK} set 3 hidden on
          fi
        fi
      done
      echo
      echo "Done. press Enter to continue "
      read ANYKEY
      ;;
    T)
      #parted -s ${MYDISK} set 1 hidden on set 2 hidden on set 3 hidden off set 3 boot on
      for ID in ${MYTEST} ; do
        CHECK=$(grep "^ ${ID} " ${TEMP1})
        if [ -n "${CHECK}" ] ; then
          if [ "${ID}" == "1" ]; then
            echo "set partition 1 hidden on"
            parted -s ${MYDISK} set 1 hidden on
          fi
          if [ "${ID}" == "2" ]; then
            echo "set partition 2 hidden on"
            parted -s ${MYDISK} set 2 hidden on
          fi
          if [ "${ID}" == "3" ]; then
            echo "set partition 3 hidden off"
            parted -s ${MYDISK} set 3 hidden off
            echo "set partition 3 boot on"
            parted -s ${MYDISK} set 3 boot on 
          fi
        fi
      done
      echo
      echo "Done. press Enter to continue "
      read ANYKEY
      ;;
    N)
      #parted -s ${MYDISK} set 1 hidden off set 2 hidden off set 3 hidden off
      for ID in ${MYTEST} ; do
        CHECK=$(grep "^ ${ID} " ${TEMP1})
        if [ -n "${CHECK}" ] ; then
          if [ "${ID}" == "1" ]; then
            echo "set partition 1 hidden off"
            parted -s ${MYDISK} set 1 hidden off
          fi
          if [ "${ID}" == "2" ]; then
            echo "set partition 2 hidden off"
            parted -s ${MYDISK} set 2 hidden off
          fi
          if [ "${ID}" == "3" ]; then
            echo "set partition 3 hidden off"
            parted -s ${MYDISK} set 3 hidden off
          fi
        fi
      done
      echo
      echo "Done. press Enter to continue "
      read ANYKEY
      ;;
    X)
      if [ -f "/root/${MYSTART}" ] ; then
        exec sh backup.sh ${MYAREA}
      else
        echo "You need to exit and run command \"sh backup.sh\""
        exit
      fi
      ;;
    Y)
      echo "wget http://${MYSERVER}/cloning/${MYAREA}/${MYAREA}-${MYHD}.mbr -O -|dd of=${MYDISK}"
### start RESTORE master boot record
      wget "http://${MYSERVER}/cloning/${MYAREA}/${MYAREA}-${MYHD}.mbr" -O -|dd of=${MYDISK}
### end here
      echo "------------------------------------"
      echo "Done. M Restore Ok  "
      echo "------------------------------------"
     # echo "Done. press Enter to continue "
     # read ANYKEY
     # ;;

    #P)
      echo "wget http://${MYSERVER}/cloning/${MYAREA}/${MYAREA}-${MYHD}.part -O -|sfdisk --force ${MYDISK}"
### start RESTORE partition table
      wget "http://${MYSERVER}/cloning/${MYAREA}/${MYAREA}-${MYHD}.part" -O -|sfdisk --force ${MYDISK}
      sleep 5
      fdisk -l ${MYDISK}|grep "^${MYDISK}"|grep -v -i "Extended" > ${TEMP1}
      MYTEST="1 2 3 4 5 6 7 8 9"
      for ID in ${MYTEST} ; do
        CHECK=$(grep "^${MYDISK}${ID} " ${TEMP1})
        if [ -n "${CHECK}" ] ; then
          IS_NTFS=$(echo ${CHECK}|grep -i "NTFS")
          if [ -n "${IS_NTFS}" ] ; then
            echo "mkntfs -f -F ${MYDISK}${ID}"
            mkntfs -f -F ${MYDISK}${ID}
          else
            IS_FAT=$(echo ${CHECK}|grep -i "FAT")
            if [ -n "${IS_FAT}" ] ; then
              echo "mkfs.vfat ${MYDISK}${ID}"
              mkfs.vfat ${MYDISK}${ID}
            else
              IS_EXT=$(echo ${CHECK}|grep -i -w "83")
              if [ -n "${IS_EXT}" ] ; then
                echo "mkfs.ext3 ${MYDISK}${ID}"
                mkfs.ext3 ${MYDISK}${ID}
              else
                IS_SWAP=$(echo ${CHECK}|grep -i -w "82")
                if [ -n "${IS_SWAP}" ] ; then
                  echo "mkswap ${MYDISK}${ID}"
                  mkswap ${MYDISK}${ID}
                fi
              fi
            fi
          fi
        fi
      done
### end here
      echo
      echo "------------------------------------"
      echo "Done. P Restore Ok  "
      echo "Done. press Enter to continue "
      echo "------------------------------------"
      read ANYKEY
      ;;
    V)
      echo "!!! Server to Reboot Now Please Wait..."
      reboot 
      ;; 
    W)
      echo "!!! Server to Shutdown Now Please Wait..."
      poweroff 
      ;; 
    *)
      continue
      ;; 
  esac
done

rm ${TEMP1} ${TEMP2}
